Create Lead
Lead Assignment & Routing
Assignment priority:
- If
assignedUserIdis provided, the lead is directly assigned to that agent. No routing rules are applied. - If
assignedUserIdis empty or omitted, the lead goes through automatic lead routing based on the configured routing rules.
Routing rule scope (when routing is triggered):
assignGroupId = -1→ Apply company-level routing rules.assignGroupId = <officeId>→ Apply routing rules for the specified office.assignGroupIdnot set → Default routing rules will be applied according to the lead’s ownership scope.
Routing location matching:
- For Seller (1) type leads, routing is determined by the
propertyfield (property address/location). - For all other lead types (Buyer, Renter, etc.), routing is determined by
inquiry.locations[](interested areas).
Lead Ownership
Controls the visibility scope of the lead:
ownershipScope = TEAM→ Account-wide: visible to all users in this Lofty client account.ownershipScope = OFFICE→ Visible to a specific office. Must provideownershipIdwith the office ID.ownershipScope = PERSONAL→ Visible only to the assigned agent. Must provideownershipIdwith the agent’s user ID.- If not specified, defaults to PERSONAL scope owned by the API caller.
Note:
ownershipScope = TEAMrefers to the entire client account (the organization), not the Lofty “Team add-on” product.
Eventual consistency
Persistence is asynchronous. The lead ID is returned immediately, but subsequent GET /v1.0/leads/ and similar read endpoints may briefly return 404 right after create. Follow-up writes (PUT, POST inquiry, POST property, POST transaction) are unaffected.
Property block
The optional property block is persisted together with the lead:
- Omit it entirely if you don’t need to attach an address — the lead is still created.
- If provided, at least one of
city,state,zipCode,streetAddressmust be non-blank; otherwise the request is rejected with 200057 PROPERTY_ADDRESS_EMPTY and no lead is created.
curl --request POST \
--url https://api.lofty.com/v1.0/leads \
--header 'Authorization: <authorization>' \
--header 'Content-Type: <content-type>' \
--data '
{
"firstName": "Bob",
"cannotText": true,
"cannotCall": true,
"cannotEmail": true,
"lastName": "Li",
"emails": [
"jane.doe@example.com",
"jdoe-work@company.com"
],
"phones": [
"+14155551234",
"+12125559876"
],
"leadTypes": [
2,
5
],
"assignedUserId": 10000000514,
"streetAddress": "The White House,1600 Pennsylvania Avenue NW",
"city": "Washington DC",
"state": "Washington DC",
"zipCode": "20500",
"referredBy": "Jeremy Kelly",
"stage": "Pending",
"groups": [
"VIP Clients",
"Open House Feb"
],
"segments": [
"First-Time Buyers",
"Downtown Area"
],
"tags": [
"Hot Lead",
"Zillow"
],
"tagsAdd": [
"Referral",
"Pre-Approved"
],
"source": "Open House",
"inquiry": {
"priceMin": 1,
"priceMax": 10000000,
"propertyType": [
"Single Family Home",
"Condo"
],
"bedroomsMin": 1,
"bathroomsMin": "1",
"locations": [
{
"city": "Austin",
"stateCode": "TX"
}
],
"id": 123,
"leadUserId": 123,
"bedroomsMax": 123,
"bathroomsMax": "<string>",
"modifyByAgent": true,
"createTime": "2023-11-07T05:31:56Z",
"updateTime": "2023-11-07T05:31:56Z",
"defaultValue": true
},
"property": {
"price": 100000,
"state": "California",
"city": "New York",
"streetAddress": "22348 Regnart RD",
"zipCode": "25401",
"county": "<string>",
"propertyType": "Single Family Home",
"bedrooms": 3,
"bathrooms": 2,
"squareFeet": 100,
"lotSize": 26.33,
"parkingSpace": 1,
"floors": 1,
"mailAddress": true,
"id": 123,
"leadUserId": 123,
"listingId": "<string>",
"autoListingId": 123,
"label": "<string>",
"note": "<string>",
"listingStatus": "<string>",
"labelList": "<string>",
"pictureUrl": "<string>",
"siteListingUrl": "<string>",
"labelType": "<string>",
"priceMax": 10000000,
"priceMin": 100000
},
"unsubscription": true,
"welcomeEmail": true,
"leadAlert": true,
"customAttributeList": [
{
"attributeName": "<string>",
"attributeType": "number, text, date, anniversary_date, single_select, multi_select, percentage, currency",
"value": "<string>",
"params": "<string>"
}
],
"birthday": "Jun 5, 2001",
"leadRouting": true,
"assignGroupId": 123,
"buyingTimeFrame": "6-12",
"preQual": "Yes",
"houseToSell": "Yes",
"fthb": "Yes",
"withBuyerAgent": "Yes",
"sellingTimeFrame": "1-3",
"mortgage": "Yes",
"buyHouse": "Yes",
"withListingAgent": "Yes",
"leadFamilyMemberList": [
{
"firstName": "<string>",
"relationship": "<string>",
"lastName": "<string>",
"phones": [
"+14155551234"
],
"emails": [
"spouse@example.com"
],
"birthday": "<string>"
}
],
"language": "en",
"content": "example_note",
"isPin": false,
"ownershipId": 123,
"ownershipScope": "<string>",
"defaultInquiryParam": true,
"specifiedAssignGroupId": true
}
'import requests
url = "https://api.lofty.com/v1.0/leads"
payload = {
"firstName": "Bob",
"cannotText": True,
"cannotCall": True,
"cannotEmail": True,
"lastName": "Li",
"emails": ["jane.doe@example.com", "jdoe-work@company.com"],
"phones": ["+14155551234", "+12125559876"],
"leadTypes": [2, 5],
"assignedUserId": 10000000514,
"streetAddress": "The White House,1600 Pennsylvania Avenue NW",
"city": "Washington DC",
"state": "Washington DC",
"zipCode": "20500",
"referredBy": "Jeremy Kelly",
"stage": "Pending",
"groups": ["VIP Clients", "Open House Feb"],
"segments": ["First-Time Buyers", "Downtown Area"],
"tags": ["Hot Lead", "Zillow"],
"tagsAdd": ["Referral", "Pre-Approved"],
"source": "Open House",
"inquiry": {
"priceMin": 1,
"priceMax": 10000000,
"propertyType": ["Single Family Home", "Condo"],
"bedroomsMin": 1,
"bathroomsMin": "1",
"locations": [
{
"city": "Austin",
"stateCode": "TX"
}
],
"id": 123,
"leadUserId": 123,
"bedroomsMax": 123,
"bathroomsMax": "<string>",
"modifyByAgent": True,
"createTime": "2023-11-07T05:31:56Z",
"updateTime": "2023-11-07T05:31:56Z",
"defaultValue": True
},
"property": {
"price": 100000,
"state": "California",
"city": "New York",
"streetAddress": "22348 Regnart RD",
"zipCode": "25401",
"county": "<string>",
"propertyType": "Single Family Home",
"bedrooms": 3,
"bathrooms": 2,
"squareFeet": 100,
"lotSize": 26.33,
"parkingSpace": 1,
"floors": 1,
"mailAddress": True,
"id": 123,
"leadUserId": 123,
"listingId": "<string>",
"autoListingId": 123,
"label": "<string>",
"note": "<string>",
"listingStatus": "<string>",
"labelList": "<string>",
"pictureUrl": "<string>",
"siteListingUrl": "<string>",
"labelType": "<string>",
"priceMax": 10000000,
"priceMin": 100000
},
"unsubscription": True,
"welcomeEmail": True,
"leadAlert": True,
"customAttributeList": [
{
"attributeName": "<string>",
"attributeType": "number, text, date, anniversary_date, single_select, multi_select, percentage, currency",
"value": "<string>",
"params": "<string>"
}
],
"birthday": "Jun 5, 2001",
"leadRouting": True,
"assignGroupId": 123,
"buyingTimeFrame": "6-12",
"preQual": "Yes",
"houseToSell": "Yes",
"fthb": "Yes",
"withBuyerAgent": "Yes",
"sellingTimeFrame": "1-3",
"mortgage": "Yes",
"buyHouse": "Yes",
"withListingAgent": "Yes",
"leadFamilyMemberList": [
{
"firstName": "<string>",
"relationship": "<string>",
"lastName": "<string>",
"phones": ["+14155551234"],
"emails": ["spouse@example.com"],
"birthday": "<string>"
}
],
"language": "en",
"content": "example_note",
"isPin": False,
"ownershipId": 123,
"ownershipScope": "<string>",
"defaultInquiryParam": True,
"specifiedAssignGroupId": True
}
headers = {
"Authorization": "<authorization>",
"Content-Type": "<content-type>"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: '<authorization>', 'Content-Type': '<content-type>'},
body: JSON.stringify({
firstName: 'Bob',
cannotText: true,
cannotCall: true,
cannotEmail: true,
lastName: 'Li',
emails: ['jane.doe@example.com', 'jdoe-work@company.com'],
phones: ['+14155551234', '+12125559876'],
leadTypes: [2, 5],
assignedUserId: 10000000514,
streetAddress: 'The White House,1600 Pennsylvania Avenue NW',
city: 'Washington DC',
state: 'Washington DC',
zipCode: '20500',
referredBy: 'Jeremy Kelly',
stage: 'Pending',
groups: ['VIP Clients', 'Open House Feb'],
segments: ['First-Time Buyers', 'Downtown Area'],
tags: ['Hot Lead', 'Zillow'],
tagsAdd: ['Referral', 'Pre-Approved'],
source: 'Open House',
inquiry: {
priceMin: 1,
priceMax: 10000000,
propertyType: ['Single Family Home', 'Condo'],
bedroomsMin: 1,
bathroomsMin: '1',
locations: [{city: 'Austin', stateCode: 'TX'}],
id: 123,
leadUserId: 123,
bedroomsMax: 123,
bathroomsMax: '<string>',
modifyByAgent: true,
createTime: '2023-11-07T05:31:56Z',
updateTime: '2023-11-07T05:31:56Z',
defaultValue: true
},
property: {
price: 100000,
state: 'California',
city: 'New York',
streetAddress: '22348 Regnart RD',
zipCode: '25401',
county: '<string>',
propertyType: 'Single Family Home',
bedrooms: 3,
bathrooms: 2,
squareFeet: 100,
lotSize: 26.33,
parkingSpace: 1,
floors: 1,
mailAddress: true,
id: 123,
leadUserId: 123,
listingId: '<string>',
autoListingId: 123,
label: '<string>',
note: '<string>',
listingStatus: '<string>',
labelList: '<string>',
pictureUrl: '<string>',
siteListingUrl: '<string>',
labelType: '<string>',
priceMax: 10000000,
priceMin: 100000
},
unsubscription: true,
welcomeEmail: true,
leadAlert: true,
customAttributeList: [
{
attributeName: '<string>',
attributeType: 'number, text, date, anniversary_date, single_select, multi_select, percentage, currency',
value: '<string>',
params: '<string>'
}
],
birthday: 'Jun 5, 2001',
leadRouting: true,
assignGroupId: 123,
buyingTimeFrame: '6-12',
preQual: 'Yes',
houseToSell: 'Yes',
fthb: 'Yes',
withBuyerAgent: 'Yes',
sellingTimeFrame: '1-3',
mortgage: 'Yes',
buyHouse: 'Yes',
withListingAgent: 'Yes',
leadFamilyMemberList: [
{
firstName: '<string>',
relationship: '<string>',
lastName: '<string>',
phones: ['+14155551234'],
emails: ['spouse@example.com'],
birthday: '<string>'
}
],
language: 'en',
content: 'example_note',
isPin: false,
ownershipId: 123,
ownershipScope: '<string>',
defaultInquiryParam: true,
specifiedAssignGroupId: true
})
};
fetch('https://api.lofty.com/v1.0/leads', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
{
"leadId": 651095960136641
}"<string>""<string>""<string>"firstName, lastName, groups, segments are truncated to 30 characters; tags / tagsAdd to 64 characters. The API returns success with no error. Validate input length before sending.Body
Lead info that needs to be added in
The first/given name of the lead Caution: Max limit 30 characters. If you exceed the limit, the import will succuss, but only import 30 characters in front.
"Bob"
false: can send message to the lead
false: can call to the lead
false: can email to the lead
The last/family name of the lead Caution: Max limit 30 characters. If you exceed the limit, the import will succuss, but only import 30 characters in front.
"Li"
A list of email addresses associated with the lead
[
"jane.doe@example.com",
"jdoe-work@company.com"
]
A list of phone numbers associated with the lead. (No more than 20 characters per phone)
["+14155551234", "+12125559876"]
Types of lead, expressed by ID. Type ID : Other (-1), Seller (1), Buyer (2), Renter (5), Investor (6), Agent (7), Homeowner (8), Landlord (9)
[2, 5]
ID of the agent to directly assign this lead to. When provided, automatic lead routing is skipped. When omitted or empty, the lead is routed automatically based on routing rules.
10000000514
The streetAddress associated with the lead. Deprecated: please use the streetAddress field in property instead.
"The White House,1600 Pennsylvania Avenue NW"
The city associated with the lead. Deprecated: please use the city field in property instead.
"Washington DC"
The state associated with the lead. Deprecated: please use the state field in property instead.
"Washington DC"
ZipCode. Deprecated: please use the zipCode field in property instead.
"20500"
The referee of the lead
"Jeremy Kelly"
The stage the lead is in, less than 20 characters
"Pending"
The groups the lead is in. Caution: Max limit 30 characters. If you exceed the limit, the import will succeed, but only import 30 characters in front. Deprecated, use segments instead.
["VIP Clients", "Open House Feb"]
The segments the lead is in. Caution: Max limit 30 characters. If you exceed the limit, the import will succeed, but only import 30 characters in front.
["First-Time Buyers", "Downtown Area"]
The tags associated with the lead. All existing tags will be updated based on this call. Caution: Max limit 64 characters. If you exceed the limit, the import will succeed, but only import 64 characters in front.
["Hot Lead", "Zillow"]
The tags associated with the lead. All existing tags will be retained, only add new tags based on this call. Caution: Max limit 64 characters. If you exceed the limit, the import will succeed, but only import 64 characters in front.
["Referral", "Pre-Approved"]
The source of the lead
"Open House"
LeadInquirys
Show child attributes
Show child attributes
Lead property or mailing address details
Show child attributes
Show child attributes
Unsubscription the email
send Welcome Email. (Not supporting update)
send new lead alert email. (Not supporting update)
User customized field
Show child attributes
Show child attributes
The birthday of the lead(pattern:MMM d, yyyy)
"Jun 5, 2001"
Deprecated. Lead routing is now automatically applied when assignedUserId is not provided. This field has no effect.
Specifies which routing rule scope to apply when automatic lead routing is triggered (i.e., assignedUserId is not provided). Set to -1 to use company-level routing rules. Set to a specific office ID to use that office's routing rules. If omitted, default routing rules will be applied according to the lead’s ownership scope.
buying time frame, 1-3, 3-6, 6-12, 12+, Just Looking, Refinancing.
"6-12"
Pre-qual, Yes or No.
"Yes"
House to Sell, Yes or No.
"Yes"
first time home buyer, Yes or No.
"Yes"
With buyer Agent, Yes or No.
"Yes"
selling time frame, 1-3, 3-6, 6-12, 12+, Just Looking, Refinancing.
"1-3"
Mortgage, Yes or No.
"Yes"
Buy a house, Yes or No.
"Yes"
With listing agent, Yes or No.
"Yes"
Show child attributes
Show child attributes
A list of family members associated with the lead. You can add up to 4 family members.
Show child attributes
Show child attributes
The lead's abbreviated language, en, fr, de, es, zh-CN, zh-TW, ja
"en"
Note content
"example_note"
Pin this note or not
false
The entity ID for the ownership scope. Required when ownershipScope is OFFICE (pass the office ID) or PERSONAL (pass the agent's user ID). Ignored when ownershipScope is TEAM.
Controls the visibility scope of the lead. TEAM — Account-wide: visible to all users in this Lofty client account. OFFICE — visible only within the specified office (requires ownershipId). PERSONAL — visible only to the specified agent (requires ownershipId). Defaults to PERSONAL scope owned by the API caller if not specified. Note: ownershipScope = TEAM refers to the entire client account (the organization), not the Lofty "Team add-on" product.
Response
Lead created.
Response containing the lead ID.
ID of the lead.
651095960136641
